;***********************************
;	: 祢 ᥩ
;	e-mail: mp3vkarmane@nm.ru
;	http://mp3vkarmane.nm.ru
;***********************************

;   ࠧ  PICa 

#define  old_config   1
; 1 - ⠭⭠ ࠧ 1 (ᮮ⢥ 奬 #1)
; 0 - ࠧ 2 (᫨ ᪮஢ 訢 ⠢ old_config 0
;    㤥    奬,  #2 㤥 ࠡ 
; , ࠭  ⮬ 筮  ⢮)


 	LIST p=PIC16F73, R=DEC
	INCLUDE "p16f73.inc"
	title "MP3 player using MultiMediaCard"
        __CONFIG _WDT_OFF & _BODEN_OFF & _HS_OSC & _CP_OFF & _PWRTE_ON


;  㪠   VS1001k  :
XTALI   equ   24576

;      VS
            if(XTALI/16000 > 0)
FREQ equ XTALI/2
            else
FREQ equ XTALI/2 + 0x8000
            endif


;  ᫮  ᫮  3   dest=dest+src
add_24      MACRO src,dest
            LOCAL _addnxt
                                     ; sorry, but some comments on eglish...
        movf    src+2,W              ; add LSB byte of src
        addwf   dest+2,F             ; to LSB of dst
        btfss   STATUS,C             ; test if carry
        goto    _addnxt              ; no carry
        incf    dest+1,F             ; carry ocurred: increment high bytes
        btfsc   STATUS,Z             ; of dest
        incf    dest+0,F
_addnxt
        movf    src+1,W              ; add 2nd byte of src
        addwf   dest+1,F             ; to second byte of dest
        btfsc   STATUS,C             ; test if carry
        incf    dest+0,F             ; carry: increment MSB of dest
        movf    src+0,W              ; finally add MSB of src to MSB of dest
        addwf   dest+0,F
            ENDM



;     MMC
CMD0     equ  0x40                   ; 
CMD1     equ  0x41                   ; 樠
CMD16    equ  0x50                   ; ࠧ   筮 
CMD17    equ  0x51                   ;  

;***************************************************************************
;  DATA SECTION
;***************************************************************************

; 祩  稭  0x20
         cblock 0x20
          cmd_num                    ; ३  MMC:  
          arg0:4                     ; ------"----"------ 㬥
          crc                        ; ------"----"------ CRC

          answer                     ; ⢥ ᫥ send_cmd
          tmpz:2                 ; 稪 থ

          vol                        ; ஬

          clus_base  :3              ;  "㫥" 
          fat_base   :3              ;  FAT
          root_base  :3              ;  ୥ ⠫
          root_entry :2

          file_size  :4              ; ⥪騩 ࠧ 
          uptoclus   :3              ; 稪

          sect_clus  :2              ; ᫮ ᥪ஢  ; +0 - doubled
                                     ; +1 - normal
          next_clus  :2              ; ᫥.   楯窥
          mystat                     ; 直 䫠
          counter    :2              ;  稪

          track_num  :2              ; 㪠⥫    ୥ ⠫
          keyb_count                 ; 稪 ணࠬ প 
                                     ; ᫥. ﬨ  
          key_cmd                    ; 䫠  

          w_temp                     ; ६ ࠭ W,STATUS,FSR
          st_temp                    ;  믮 뢠
          fsr_temp
                                     ; 㬥 mult:
          msrc        :3             ; 
          mmul                       ; ⥫
          mrslt       :4             ; १

          ffirst      :3
          tmpy:2
          tmpx:2
          id3_len:2
          spi2
          spi2_tmp
         endc

;  mystat
_bass_ext    equ   7                  ; bass/teble enhanser
_block_err   equ   6                  ; 訡  ⪥  
_seek_up     equ   5                  ; ᪠ ।
_seek_dn     equ   4                  ; ᪠ 
_find_start  equ   3
_playstop    equ   2                  ; 1-ࠥ 0-⠭
_skip_id3    equ   1

; key_cmd
_keyb_ask    equ   7                  ;    믮
_volm        equ   6                  ;  ஬
_seek        equ   5                  ; 믮 ப

;***************************************************************************
;  CODE SECTION
;***************************************************************************
	org 0
	goto _start               ;   砫

        org 4
;
;  뢠 ஢塞 ⨥  
; ᯮ 뢠  TIMER0.
;
        movwf  w_temp             ; o࠭塞  祭
        swapf  STATUS,w           ; ॣ஢ W,STATUS & FSR
        movwf  st_temp
        swapf  FSR,W
        movwf  fsr_temp

        btfss  INTCON,T0IF
        goto   _chk2isr

        bcf    INTCON,T0IF        ;  뢠
        call   test_keys          ; ஢ 
        goto   _stopisr
_chk2isr

_stopisr
        swapf  fsr_temp,w         ; ⠭ 祭 ॣ஢
        movwf  FSR
        swapf  st_temp,w
        movwf  STATUS
        swapf  w_temp,f
        swapf  w_temp,w
        retfie                    ; 室
;_____________________________________________________________________________
           if old_config
#include   "io_1.asm"
           else
#include   "io_2.asm"
           endif
#include   "vs_1.asm"
;_____________________________________________________________________________

_start
        clrf    STATUS
        clrf    INTCON           ;   뢠
        clrf    PORTA
        clrf    PORTB
        clrf    PORTC

        BSF	STATUS, RP0      ; Goto Bank 1
        movlw   0x07
	movwf	OPTION_REG
        movlw	0x07		;   - ஢
	movwf	ADCON1
        clrf    TRISC
        clrf    TRISB
        clrf    TRISA
        bsf     key0
        bsf     key1
        bsf     key2
        bsf     key3
        bsf     bit_spi_in      ; 室
        bsf     bit_vs_dreq
        bsf     bit_spi2_in
	BCF	STATUS, RP0      ;  Goto Bank 0

        movf    PORTB,W
        bcf     INTCON,RBIF

        bsf      bit_mmc_cs          ; 몫 롮 MMC
        bsf      bit_vs_cs           ;  VS

	clrf	ADCON0

	;   ந  SPI
        BSF     STATUS,RP0       ;  1
        movlw   1<<CKE           ;   ஭,ᤢ  ᯠ
	movwf   SSPSTAT          ; 砫쭮 ﭨ '0'
	BCF     STATUS,RP0       ;  0
	BSF     SSPCON,SSPEN     ; ࠧ蠥 SPI


        ; ன  USART
        BSF     STATUS,RP0       ;  1
        movlw   (1<<CSRC)|(1<<SYNC)
        movwf   TXSTA            ; ᨭ஭ master, ࠧ ।
        bsf     TXSTA,TXEN
        BCF     STATUS,RP0       ;  0
        BSF     RCSTA,SPEN       ; ࠧ蠥 USART


        movlw   0x20             ; ⨬ RAM  㫥 
        movwf   FSR              ; --
_clr_ram                         ; --
        clrf    INDF             ; --
        incf    FSR,F            ; --
        btfss   FSR,7            ; --
        goto    _clr_ram         ; --

        movlw   0x08
        movwf   keyb_count

        movlw   0x30             ; ⠭ । ஬
        movwf   vol

        call    rehard_vs        ; 믮   VS

        call    init_mmc         ; 樠 MMC

        call    init_fat         ;  ॣ஢ PIC 
                                 ; ࠢ쭮 ࠡ  FAT

        bsf     INTCON,T0IE      ; ࠧ 뢠  ⠩0
        bsf     INTCON,PEIE      ; --

        bsf     mystat,_playstop ; ࠧ ३  ﭨ play

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;   横 - ।   mmc  vs
;

_main_loop
        call    resoft_vs        ;  VS  ந । 
                                 ; ४

        btfss   mystat,_playstop ;   stop?
        call    in_idle          ;  - ⠭  믠

        bcf     key_cmd,_keyb_ask

        call    seek_dir         ;  ᫥. ४

_loop_cluster
        call    reload_cluster   ;   ᫥. ,
                                 ; ।騩 ॢ    arg0[3..0]

        ;>>>>>>>>> । ᫥騩 
        ; 砫   arg[3..0]

        movf    sect_clus+1,W
        movwf   uptoclus+0       ; 稪 ᫠ ᥪ஢
_next512
        movlw   0x10
        movwf   uptoclus+1       ; 稪 ᫠ 32- ⮢  ᥪ
_next32
        bsf     INTCON,GIE
        btfss   bit_vs_dreq          ;   
        goto    $-1
        bcf     INTCON,GIE

        ;
        ; ।   32 
        ;
        movlw    CMD17
        movwf    cmd_num

        bcf     bit_mmc_cs
         call    send_cmd
         call    wait_data

         movlw   d'32'
         movwf   uptoclus+2
                                   ; ᥩ  ᫠  vs 32 
         movlw   0xff              ; ⮡   ६ , ⠥
         movwf   SSPBUF            ;    襬   ࠫ쭮
         bsf     STATUS,RP0
         btfss   SSPSTAT,BF        ; ।/ਥ 襭?
         goto    $-1               ;  - 
         bcf     STATUS,RP0
_send32
         movf    SSPBUF,w          ; ⠫   mmc
         btfsc   mystat,_skip_id3     ; ᫨   ID3v2 - ய
         call    skip_id3_tag
         bsf	 bit_vs_bsync
         movwf	 TXREG             ; 稭  ।
         movlw   0xff
         movwf   SSPBUF            ;  ६ ਥ ᫥饣
         bcf	 bit_vs_bsync
         nop
         nop
         nop
         nop

         decfsz   uptoclus+2,f
         goto     _send32

         call     get_spi
         call     get_spi
         call     get_spi
        bsf     bit_mmc_cs
        ; 32  ।

        bsf     INTCON,GIE
        movlw   d'32'              ; 㢥祭  ᫥.   32
        addwf   arg0+3,f
        movlw   0x1
        btfsc   STATUS,C
        addwf   arg0+2,F
        btfsc   STATUS,C
        addwf   arg0+1,F
        btfsc   STATUS,C
        addwf   arg0+0,F
        bcf     INTCON,GIE

        movlw   d'32'              ; 㬥襭 ࠧ ⪠  32
        subwf   file_size+3,f
        movlw   0x1
        btfss   STATUS,C
        subwf   file_size+2,F
        btfss   STATUS,C
        subwf   file_size+1,F
        btfss   STATUS,C
        subwf   file_size+0,F
        btfss   STATUS,C
        goto    _finished

        decfsz  uptoclus+1,F           ; ᫠ 512 ?
        goto    _next32                ;  - ᫥. 32

        decfsz  uptoclus+0,F           ; ᫠ Sect_per_Clus ᥪ஢?
        goto    _next512               ;  - ᫥. 32
        ;<<<<<<<<<<<<< transmit finished

        btfss   key_cmd,_keyb_ask      ;  ?
        goto    _nokeybs
        bcf     key_cmd,_keyb_ask      ;  - ࠧ ਥ ᫥. 
        btfss   key_cmd,_seek          ; ப⪠?
        goto    _setvol                ; 
        goto    _main_loop             ;  -    砫
_setvol
        btfsc   key_cmd,_volm
        call    write_vol              ;  ஬

_nokeybs
        movlw   0xff                   ; ᫥.  -  楯窨?
        xorwf   next_clus+0,W
        btfss   STATUS,Z
        goto    _loop_cluster          ;  - ४  祭
        movlw   0xF8
        andwf   next_clus+1,W
        xorlw   0xF8
        btfss   STATUS,Z
        goto    _loop_cluster          ;  - ४  祭
                                       ;  - ४ 襭.
_finished
        call    send_2048              ;  ୮ ᫠ 2048 㫥
        bcf     mystat,_seek_dn        ; ࠢ ᪠ - 
        bsf     mystat,_seek_up

        goto    _main_loop
;
;  end of main loop
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
skip_id3_tag
        movwf   tmpx
        movlw   0x01
        subwf   id3_len+1,f
        btfsc   STATUS,C
        retlw   0x00
        movlw   0x01
        subwf   id3_len,f
        btfsc   STATUS,C
        retlw   0x00
        bcf     mystat,_skip_id3
        movf    tmpx,w
        return

;----------------------------------------------------------
; in_idle - 뢮 奬  ०  ࣮ॡ
;    ୮ ᪠
; ᫥ ⮣ 뢠 MMC, VS
;----------------------------------------------------------

in_idle
        bsf     STATUS,RP0
        if old_config
        movlw   0x87             ; 㡨ࠥ 寧(⮡ RB0  RB1 
        movwf   OPTION_REG       ; ॡ﫨;  뫮 ९,   ⥫ 奬 )
        endif
        movlw   b'00100000'      ; 室 - ⮫쪮  祭
        movwf   TRISB
        bcf     STATUS,RP0
        clrf    PORTB
        clrf    INTCON

_wrong_start
        call    delay_05s
        btfss   key1
        goto    $-1
        bsf     INTCON,RBIE
        movf    PORTB,W
        bcf     INTCON,RBIF
        sleep
        nop
        bcf     INTCON,RBIE
        movf    PORTB,W
        bcf     INTCON,RBIF

        call    delay_05s
        call    delay_05s

        movf    PORTB,W
        btfsc   key1
        goto    _wrong_start

        clrf    INTCON
        bsf     INTCON,T0IE
        bsf     INTCON,PEIE

        bsf     STATUS,RP0
        movlw   0x07
        movwf   OPTION_REG
        movlw   b'00111100'
        movwf   TRISB
        bcf     STATUS,RP0

        bsf     mystat,_playstop
        call    init_mmc
        goto    rehard_vs
;-----------------------------------------------------------------------------
; 4 ࠧ ""
nocard
        movlw   d'82'
        call    beep
        movlw   d'73'
        call    beep
;  ࠧ ""
nocard2
        movlw   d'82'
        call    beep
        movlw   d'73'
        call    beep
        goto    $
;-----------------------------------------;
; 㭪: delay_500us                    ;
; প  500us                        ;
;-----------------------------------------;
delay_500us
        movlw d'249'
        movwf tmpz

        nop
        nop
        decfsz tmpz,f
        goto   $-3

        return

;----------------------------------------;
; 㭪: delay_01s                     ;
; প  0,1ᥪ.                     ;
;----------------------------------------;
delay_01s
        movlw d'100'
        movwf tmpz+1

_00001
        call  delay_500us
        call  delay_500us
        decfsz tmpz+1,f
        goto   _00001

        return

delay_05s
        movlw d'250'
        movwf tmpz+1

_00002
        call  delay_500us
        call  delay_500us

        call  delay_500us
        call  delay_500us
        decfsz tmpz+1,f
        goto   _00002

        return

;--------------------------------------------------------;
;   㭪: seek_dir                                    ;
;   饬   ᫥. ४.                     ;
;      next_clus, ࠧ  file_size       ;                         ;
;--------------------------------------------------------;
seek_dir
        movlw  0x4
        call   set_size
_ifup
        btfss  mystat,_seek_up
        goto   _noup
                                       ;  ।
        incf    track_num+1,f
        btfsc   STATUS,Z
        incf    track_num,f

        movf    root_entry,w
        xorwf   track_num,w
        btfss   STATUS,Z
        goto    _check_it
        movf    root_entry+1,w
        xorwf   track_num+1,w
        btfss   STATUS,Z
        goto    _check_it


        clrf   track_num+0             ; ᫨ ⨣  - ३ 
        clrf   track_num+1             ; 砫 ⠫
        goto   _check_it
        return
_noup
        btfss  mystat,_seek_dn
        goto   _nodn
                                       ;  
        decfsz track_num+1,F
        goto   _check_it
        movf   track_num+0,F
        btfsc  STATUS,Z
        goto   _lowlimit
        decf   track_num+0,F
        goto   _check_it
_lowlimit
        movf   root_entry+1,w          ; 諨  㫥  - ३
        movwf  track_num+1             ;  ᫥
        movf   root_entry,w
        movwf  track_num+0
        movlw  0x01
        subwf  track_num+1,f
        btfss  STATUS,Z
        decf   track_num,f
        goto   _check_it

_nodn
                                       ;  -
        bsf    mystat,_seek_up

_check_it
        movf   track_num+1,W           ; ८ࠧ  ४  ᬥ饭
        movwf  arg0+2
        movf   track_num+0,W
        movwf  arg0+1
        clrf   arg0+0
        clrf   arg0+3
        bcf    STATUS,C
        movlw  0x3
        movwf  counter
_shift3
        rrf    arg0+1,F
        rrf    arg0+2,F
        rrf    arg0+3,F
        decfsz counter,F
        goto   _shift3

        add_24 root_base,arg0          ; ਡ   
        movlw  CMD17
        movwf  cmd_num
        bcf     bit_mmc_cs
         call    send_cmd
         call    wait_data
         call    get_spi
         movwf   tmpz              ; 㫥  
         call    get_spi
         call    get_spi
         movwf   tmpz+1            ; ன  
         call    get_spi
         call    get_spi
         call    get_spi
        bsf     bit_mmc_cs
        movlw   0xe5                   ; ᫨  㫥 0xE5 - 㤠 䠨
        xorwf   tmpz,W
        btfsc   STATUS,Z
        goto    _ifup
        movf    tmpz,W             ; ᫨  㫥 0x00 -  
        btfsc   STATUS,Z
        goto    _ifup

        movf    tmpz+1,W           ; ᫨  ஬ 0x00 - eng.
        btfsc   STATUS,Z
        goto    _ifup

        movlw   0x04
        xorwf   tmpz+1,w           ; ᫨  ஬ 0x04 - .
        btfsc   STATUS,Z
        goto    _ifup


        movlw   0x18                   ;  ⮢ 
        iorwf   arg0+3,F
        bcf     bit_mmc_cs
         call    send_cmd
         call    wait_data
         call    get_spi
         call    get_spi

         call    get_spi
         movwf   next_clus+1
         call    get_spi
         movwf   next_clus+0
         call    get_spi
         call    get_spi
        bsf     bit_mmc_cs

        movlw   0xE0                   ;  ࠧ 䠩
        andwf   arg0+3,F
        movlw   0x1c
        iorwf   arg0+3,F
        bcf     bit_mmc_cs
         call    send_cmd
         call    wait_data
         call    get_spi
         movwf   file_size+3
         call    get_spi
         movwf   file_size+2
         call    get_spi
         movwf   file_size+1
         call    get_spi
         movwf   file_size+0
         call    get_spi
         call    get_spi
        bsf     bit_mmc_cs

; ஢ਬ 稥 ⥣ ID3v2
        movlw   0x0b
        call    set_size

        movf    next_clus,w         ; ࠭  1 
        movwf   tmpx
        movf    next_clus+1,w
        movwf   tmpx+1

        call    reload_cluster

        bcf     mystat,_skip_id3
        movlw   CMD17
        movwf   cmd_num
        bcf     bit_mmc_cs
         call     send_cmd
         call     wait_data
         call     get_spi
         movwf    tmpy
         call     get_spi
         movwf    tmpy+1
         call     get_spi
         movwf    tmpz
         call     get_spi  ; 00
         call     get_spi  ; 03
         call     get_spi  ; flags
         call     get_spi  ; size
         call     get_spi  ; size+1
         call     get_spi  ; size+2
         movwf    id3_len
         call     get_spi  ; size+3
         movwf    id3_len+1

         bcf      STATUS,C
         rrf      id3_len
         btfsc    STATUS,C
         bsf      id3_len+1,7

         movlw    d'29'
         movwf    tmpz+1

         call     get_spi
         decfsz   tmpz+1,f
         goto     $-2

        bsf     bit_mmc_cs
        movlw   'I'
        xorwf   tmpy,w
        btfss   STATUS,Z
        goto    _noID3
        movlw   'D'
        xorwf   tmpy+1,w
        btfss   STATUS,Z
        goto    _noID3
        movlw   '3'
        xorwf   tmpz,w
        btfss   STATUS,Z
        goto    _noID3
                                    ; ID3v2 .
        bsf     mystat,_skip_id3
_noID3
        movf    tmpx,w            ; ⠭  ࢮ 
        movwf   next_clus
        movf    tmpx+1,w
        movwf   next_clus+1

        return
;--------------------------------------------------------;
;   㭪: reload_cluster                              ;
;   ॣ㦠  ᫥.   ஬ next_clus ;
;    arg0, 뢠  ᫥.   楯窥.    ;
;--------------------------------------------------------;
reload_cluster
        movlw   0x2
        call    set_size
        movf    next_clus+1,W
        movwf   msrc+2
        movf    next_clus+0,W
        movwf   msrc+1
        movf    sect_clus,W
        movwf   mmul

        movlw   CMD17
        movwf   cmd_num

        movf    next_clus+1,W
        movwf   arg0+3
        movf    next_clus+0,W
        movwf   arg0+2
        clrf    arg0+1
        clrf    arg0+0
        bcf     STATUS,C
        rlf     arg0+3,F
        rlf     arg0+2,F
        rlf     arg0+1,F

        add_24  fat_base,arg0

        bcf     bit_mmc_cs
         call    send_cmd
         call    wait_data
         ;btfsc   mystat,_block_err
         ;goto    nocard
         call    get_spi
         movwf   next_clus+1
         call    get_spi
         movwf   next_clus+0
         call    get_spi
         call    get_spi
         call    get_spi
        bsf     bit_mmc_cs

        movlw   d'32'
        call    set_size

        ; 襬  arg0[0..3]  ᫥. 
        call    mult
        clrf    arg0+3
        movf    clus_base+2,W
        movwf   arg0+2
        movf    clus_base+1,W
        movwf   arg0+1
        movf    clus_base+0,W
        movwf   arg0+0

        add_24  mrslt,arg0

        return
;--------------------------------------------------------;
;   㭪: mult                                        ;
;    mrslt[0..2] = msrc[1..2] * mmul            ;
;   室: msrc[1..2],  mmul; if mmul=0 then mmul=256!!!  ;
;   頥: mrslt[0..2]                              ;
;--------------------------------------------------------;

mult
        movf    mmul,w
        btfsc   STATUS,Z
        goto    _mul2_256

        clrf    msrc+0
        clrf    mrslt+0
        clrf    mrslt+1
        clrf    mrslt+2

        movlw   0x8
        movwf   counter
_addnextpow
        bcf     STATUS,C
        rrf     mmul,F
        btfss   STATUS,C
        goto    _shift2

        add_24  msrc,mrslt
_shift2
        bcf     STATUS,C
        rlf     msrc+2,F
        rlf     msrc+1,F
        rlf     msrc+0,F
        decfsz  counter,F
        goto    _addnextpow

        return

_mul2_256
        clrf    mrslt+2
        movf    msrc+2,w
        movwf   mrslt+1
        movf    msrc+1,w
        movwf   mrslt+0
        return
;-------------------------------------------------
init_mmc
        movlw    8
        movwf    tmpz
_res_lp
        movlw    CMD0
        movwf    cmd_num
        clrw
        movwf    arg0
        movwf    arg0+1
        movwf    arg0+2
        movwf    arg0+3

        bcf     bit_mmc_cs
        call    send_cmd                ; 
        bsf     bit_mmc_cs

        movlw   CMD1
        movwf   cmd_num
        bcf     bit_mmc_cs
        call    send_cmd                ;  樠樨
        bsf     bit_mmc_cs

        btfsc   answer,0        ; ᫥ ਥ ⮩  
        goto    _idle_mmc       ;  ⢥    idle_state
                                ; ᫨   ⠪ - ஡㥬  ᭮
        decfsz  tmpz,F
        goto    _res_lp


        goto    nocard          ; ᫨ ᫥ 8 ᮢ  諮 idle_state
                                ; ⠥   


_idle_mmc                       ; ⥯ ⠥ ந樠஢ 
        clrf    tmpz+1          ;  ࠧ 諥  CMD1
_svv                            ;   ந樠,  
                                ; ⢥  idle_state   
        movlw   CMD1            ; ஡㥬 65536 ࠧ
        movwf   cmd_num
        clrf    tmpz
_idle_
        bcf     bit_mmc_cs
        call    send_cmd
        bsf     bit_mmc_cs
        movf    answer,w
        btfsc   STATUS,Z
        return                  ; ᨫ - 室
        decfsz  tmpz,f
        goto    _idle_

        decfsz  tmpz+1,f
        goto    _svv

        goto    nocard          ;  㤠

;---------------------------------------------------------------------;
;   뢠  FAT,Root DIR,       ;
;    ண   ࠧ  ஢, ᫮         ;
;   (ᥪ஢   * 2)                                         ;
;   頥: fat_base,root_base,clus_base,sect_clus                ;
;---------------------------------------------------------------------;

init_fat
        movlw   0x3
        call    set_size              ; ⠭ ࠧ 뢠 
                                      ; 3 

        movlw   CMD17                 ;  MBR?
        movwf   cmd_num
        clrf    arg0
        clrf    arg0+1
        movwf   arg0+2
        movwf   arg0+3

        bcf     bit_mmc_cs
         call    send_cmd                ; 뫠  ⥭
         call    wait_data
         btfsc   mystat,_block_err
         goto    nocard2
                                         ;      ᥪ
         call    get_spi                 ;   ଠ LSB
         movwf   arg0+2
         call    get_spi
         movwf   arg0+1
         call    get_spi
         movwf   arg0+0
         call    get_spi                 ; 2  crc 㥬
         call    get_spi
        bsf     bit_mmc_cs

        movf    arg0+2,w
        btfss   STATUS,Z
        goto    _no_MBR

        movlw   CMD17                    ; ⠥  ࢮ  ࠧ
        movwf   cmd_num
        clrf    arg0
        clrf    arg0+1                   ;  ࢮ  ࠧ
        movlw   0x01                     ;ᨤ  partition table 0x1BE(+0x8)
        movwf   arg0+2
        movlw   0xC6
        movwf   arg0+3

        bcf     bit_mmc_cs
         call    send_cmd                ; 뫠  ⥭
         call    wait_data
         btfsc   mystat,_block_err
         goto    nocard2
                                         ;      ᥪ
         call    get_spi                 ;   ଠ LSB
         movwf   arg0+2
         call    get_spi
         movwf   arg0+1
         call    get_spi
         movwf   arg0+0
         call    get_spi                 ; 2  crc 㥬
         call    get_spi
        bsf     bit_mmc_cs

        clrf    arg0+3
        bcf     STATUS,C
        rlf     arg0+2,F           ; ᤢ  2  祭  
        movf    arg0+2,W
        movwf   fat_base+2         ;   ࠧ
        rlf     arg0+1,F           ;
        movf    arg0+1,W
        movwf   fat_base+1
        rlf     arg0+0,F
        movf    arg0+0,W
        movwf   fat_base+0
        goto    _is_MBR
        ;>>>>>>>>>>>>>>>>>>>>>>>>
_no_MBR
        clrf    arg0+0
        clrf    arg0+1
        clrf    arg0+2
        clrf    arg0+3

        clrf    fat_base+0
        clrf    fat_base+1
        clrf    fat_base+2
        clrf    fat_base+3
        ;<<<<<<<<<<<<<<<<<<<<<<<<
_is_MBR
                                 ; ⥯ ࠧ   ᫮ ᥪ஢ 
                                 ; 
        movlw   CMD17
        movwf   cmd_num
        movlw   0x0D
        movwf   arg0+3
        bcf     bit_mmc_cs
         call    send_cmd                ; 뫠  ⥭
         call    wait_data
         btfsc   mystat,_block_err
         goto    nocard2
         call    get_spi
         movwf   sect_clus
         movwf   sect_clus+1
         call    get_spi
         movwf   tmpy+1
         call    get_spi
         movwf   tmpy+0
         call    get_spi
         call    get_spi
        bsf     bit_mmc_cs

                                   ; fat_sect.adr=boot_sect.adr+0x200
        bcf     STATUS,C
        rlf     tmpy+1,f
        rlf     tmpy,f

        movf    tmpy+1,w
        addwf   fat_base+2,F
        btfss   STATUS,C
        goto    _fatisset
        incf    fat_base+1,F
        btfss   STATUS,Z
        goto    _fatisset
        incf    fat_base+0,f
        movf    tmpy,w
        addwf   fat_base+1,F
        btfss   STATUS,C
        goto    _fatisset
        incf    fat_base+0,f
_fatisset

        btfss   sect_clus,7
        goto    _mul_sect
        movlw   0x80
        xorwf   sect_clus,W
        btfss   STATUS,Z
        goto    nocard2

_mul_sect
        bcf     STATUS,C
        rlf     sect_clus,F

        movlw   CMD17
        movwf   cmd_num
        movlw   0x16
        movwf   arg0+3
        bcf     bit_mmc_cs
         call    send_cmd                ; 뫠  ⥭
         call    wait_data
         btfsc   mystat,_block_err
         goto    nocard2
         call    get_spi                 ; ࠭ ᫮ ᥪ஢
         movwf   root_base+2             ;   
         call    get_spi
         movwf   root_base+1
         call    get_spi
         call    get_spi
         call    get_spi
        bsf     bit_mmc_cs


         clrf    root_base              ; ८ࠧ㥬 ᫮ ᥪ஢ 
         bcf     STATUS,C               ; ᫮ 
         rlf     root_base+2,F
         rlf     root_base+1,F
         rlf     root_base+0,F
         bcf     STATUS,C
         rlf     root_base+2,F
         rlf     root_base+1,F
         rlf     root_base+0,F

         add_24  fat_base,root_base
; ᬥ饭 ୥ ⠫ 
; ⥯  ன 

         movlw   CMD17
        movwf   cmd_num
        movlw   0x11
        movwf   arg0+3
        bcf     bit_mmc_cs
         call    send_cmd                ; 뫠  ⥭
         call    wait_data
         btfsc   mystat,_block_err
         goto    nocard2
         call    get_spi
         movwf   root_entry+1
         movwf   tmpy+1
         call    get_spi
         movwf   root_entry+0
         movwf   tmpy
         call    get_spi
         call    get_spi
         call    get_spi
        bsf     bit_mmc_cs

         movf    root_base+1,W
         movwf   clus_base+1
         movf    root_base+0,W
         movwf   clus_base+0

         bcf     STATUS,Z
         rrf     tmpy,f
         rrf     tmpy+1,f
         rrf     tmpy,f
         rrf     tmpy+1,f
         rrf     tmpy,f
         rrf     tmpy+1,w


         addwf   root_base+2,W
         movwf   clus_base+2
         btfss   STATUS,C
         goto    _sub_2clus
         incf    clus_base+1,F
         btfsc   STATUS,Z
         incf    clus_base+0,F
                                        ; ⥯  clus_base  ண
                                        ; .  饭 
_sub_2clus                              ; ᤥ 㪠  㫥.

         movlw   0x2
         movwf   msrc+2
         clrf    msrc+1
         movf    sect_clus,W
         movwf   mmul
         call    mult

         movf    mrslt+2,W
         subwf   clus_base+2,F
         btfsc   STATUS,C
         goto    _nosub
         decf    clus_base+1,F
         btfsc   STATUS,Z
         decf    clus_base+0,F
_nosub
         movf    mrslt+1,W
         subwf   clus_base+1,F
         btfss   STATUS,C
         decf    clus_base+0,F
         movf    mrslt+0,W
         subwf   clus_base+0,F
        return

;--------------------------------------------------------------;
;    㭪: wait_data                                        ;
;     砫 ।                  ;
;     砥 訡 ⠭ mystat,_block_err         ;
;--------------------------------------------------------------;
wait_data
         bcf     mystat,_block_err
         movlw   0x80
         movwf   counter+1
_wait_rcv
_wait_rcv2
         call    get_spi
         movwf   answer
         xorlw   0xfe
         btfsc   STATUS,Z                ;  砫  
         return
         movlw   0xE0
         andwf   answer,W

         btfsc   STATUS,Z
         goto    _err_rcv
         decfsz  counter,F
         goto    _wait_rcv2

         decfsz  counter+1,f
         goto    _wait_rcv

_err_rcv
         bsf     mystat,_block_err
         return

;---------------------------------------------------------;
;   㭪: set_size                                     ;
;   ⠭ ࠧ    ।   ;
;   室: W - ࠧ                                 ;
;---------------------------------------------------------;
set_size
        movwf    arg0+3
        movlw    CMD16
        movwf    cmd_num

        clrw
        movwf    arg0+2
        movwf    arg0+1
        movwf    arg0

        bcf      bit_mmc_cs
        call     send_cmd
        bsf      bit_mmc_cs

        return
;--------------------------------------------------------;
;   㭪: send_cmd                                    ;
;   ࠢ ३                          ;
;   室: cmd_num -   (⠭ CMDxx),     ;
;         arg0[0..3] - 㬥                   ;
;   頥: answer - ⢥                  ;
;--------------------------------------------------------;
send_cmd
        movlw   0x2
        movwf   counter+1
_try_cmd
        call    get_spi
        call    get_spi
        movlw   0x95
        movwf   crc

        movlw   0xff
        movwf   SSPBUF

        movlw   cmd_num
        movwf   FSR
        movlw   0x06
        movwf   counter
        call    get_spi
_nextincmd
        movf    INDF,W
        call    spi_out
        incf    FSR,F
        decfsz  counter,F
        goto    _nextincmd

        movlw   0x80
        movwf   counter
_wait_notff
        call    get_spi
        movwf   answer
        btfss   answer,7
        return

        decfsz  counter,F
        goto    _wait_notff

        decfsz  counter+1,F
        goto    _try_cmd
        goto    nocard2


;------------------------------------------------------------;
;   㭪: test_keys                                       ;
;   ஢ઠ ﭨ . ᫨ - ,         ;
;    ⠭  _keyb_ask   ॣ஢  ;
;   mystat, key_cmd  vol                                  ;
;------------------------------------------------------------;
test_keys
        movf   keyb_count,F           ;  ஢ ᫨ ᮡ
        btfsc  STATUS,Z               ; 2 ᫮:
        goto   _can_watch             ; 1)諮 >8 뢠  諮
        decf   keyb_count,F           ;     (.  楤)
        return
_can_watch

        btfsc  key_cmd,_keyb_ask      ; 2)।饥 ⨥ ࠡ⠭
        return

        clrf   key_cmd

        btfsc  key3                    ;  3 ?
        goto   _0not_pressed           ; 
                                       ; 
        btfsc  key1
        goto   _t00
        movlw  0x80                    ; bass/treble
        xorwf  mystat,F
        bsf    key_cmd,_volm
        goto   _send_isr

_t00
        btfss  mystat,_playstop
        return

        btfsc  key0                    ; key0 vs key3
        goto   _t02
        bsf    key_cmd,_seek           ; ६⪠ ।
        bsf    mystat,_seek_up
        bcf    mystat,_seek_dn
        goto   _send_isr
_t02
        btfsc  key2                    ; key2 vs key3
        goto   _end_isr
        bsf    key_cmd,_seek           ; ६⪠ 
        bsf    mystat,_seek_dn
        bcf    mystat,_seek_up
        goto   _send_isr

_0not_pressed                          ; 3  
        btfsc  key0
        goto   _t11
        movlw  sound_step              ; ਡ ஬
        subwf  vol,F
        btfss  STATUS,C
        clrf   vol
        bsf    key_cmd,_volm
        goto   _send_isr
_t11

        btfsc  key1                    ; key1
        goto   _t12
        bcf    mystat,_seek_up         ; ⮯
        bcf    mystat,_seek_dn
        bsf    key_cmd,_seek
        bcf    mystat,_playstop
        movlw  0x40
        movwf  keyb_count
        bsf    key_cmd,_keyb_ask
        return
_t12
        btfsc  key2
        goto   _end_isr
        bsf    key_cmd,_volm           ; 㡠 ஬
        movlw  sound_step
        addwf  vol,F
        btfss  STATUS,C
        goto   _send_isr
        clrf   vol
        decf   vol,F
        goto   _send_isr
_send_isr
        movlw  0x8                     ;   ᫨ -
        movwf  keyb_count              ;  뫠 .
        bsf    key_cmd,_keyb_ask
_end_isr
         return
;@@@@@@@; THE
             END ;@@@@@@@;





;***********************************
;	: 祢 ᥩ
;	e-mail: mp3vkarmane@nm.ru
;	http://mp3vkarmane.nm.ru
;***********************************
